#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <algorithm>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>

//nutno vytvoit vlastn funkci, protoe text nen ukonen nulovm znakem a neel by tedy vypsat
char* Convert(char* text, int length)
{
	char NewText[255];
	for (int a = 0; a < length; a++)
		*(NewText + a) = *(text + a);
	*(NewText + length) = '\0';
	return NewText;
};

int SDL_main(int, char**)
{
	//inicializace SDL - pouze video
	SDL_Init(SDL_INIT_VIDEO);
	IMG_Init(IMG_INIT_PNG);
	TTF_Init();
	//vytvoen okna
	SDL_Window* MainWindow = SDL_CreateWindow("Vykresleni textu", //jmno okna
		SDL_WINDOWPOS_CENTERED, //okno bude vytvoeno ve stedu obrazovky
		SDL_WINDOWPOS_CENTERED,
		800, 600, NULL); //ka, vka a flagy okna (ty nepotebujeme)

	TTF_Font* Font = TTF_OpenFont("Fonts/PlayfairDisplay-Black.ttf", 35);
	char TextArray[1024];
	*TextArray = ' ';		//nen mon vypsat przdn etzec
	*(TextArray + 1) = '\0';
	SDL_Color* color = new SDL_Color;
	color->a = color->r = 255;
	color->g = color->b = 0;
	SDL_Rect* rect = new SDL_Rect;
	rect->h = 35;
	rect->x = rect->y = 0;

	//vytvoen rendereru
	SDL_Renderer* renderer = SDL_CreateRenderer(MainWindow, -1, SDL_RENDERER_TARGETTEXTURE);

	SDL_LogSetAllPriority(SDL_LOG_PRIORITY_VERBOSE);

	//zjitn, zda je mon pout klvesnici na obrazovce
	if (SDL_HasScreenKeyboardSupport())
		SDL_Log("Keyboard supported");

	if (SDL_IsScreenKeyboardShown(MainWindow))
		SDL_Log("Keyboard shown");

	

	bool End = false;								//promnn, kter d hlavn smyku
	SDL_Event* event = new SDL_Event;				//struktura, kter uchovv udlosti
	while (!End)									//zatek hlavn smyky
	{
		while (SDL_PollEvent(event))				//naten udlosti z fronty
		{
			if (event->type == SDL_QUIT)				//manipulace s udlost
				End = true;								//ukonen aplikace
			if (event->type == SDL_KEYDOWN)				//aktivace a deaktivace zachytvn vstupu
			{
				if (event->key.keysym.scancode == SDL_SCANCODE_UP)
					SDL_StartTextInput();
				else if (event->key.keysym.scancode == SDL_SCANCODE_DOWN)
					SDL_StopTextInput();
			}
			//zachycen vstupu
			if (event->type == SDL_TEXTINPUT)
				strcat(TextArray, event->text.text);
			if (event->type == SDL_TEXTEDITING)
				SDL_Log("New text: %s,start: %i, length: %i",Convert(event->edit.text,event->edit.length),event->edit.start,event->edit.length);
		}

		//vykreslen textu
		SDL_Surface* TextSurf = TTF_RenderUTF8_Blended(Font, TextArray, *color);
		SDL_Texture* TextText = SDL_CreateTextureFromSurface(renderer,TextSurf);
		rect->w = TextSurf->w;

		SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);		//nastaven barvy, kterou se bude vykreslovat pozad
		SDL_RenderClear(renderer);								//vykreslen pozad

		SDL_RenderCopy(renderer,TextText,NULL,rect);			//vykreslen textu na obrazovku

		SDL_RenderPresent(renderer);							//aktualizace okna

		//klid
		SDL_DestroyTexture(TextText);	
		SDL_FreeSurface(TextSurf);


	}

	//nen poteba mazat jednotliv objekty, po ukonen programu voln msto automaticky promae OS

	TTF_Quit();								//ukonen SDL_ttf
	IMG_Quit();								//ukonen SDL_Image
	SDL_Quit();								//Ukonen SDL
	return 0;
}